﻿;=========================================== キー配列の読み込み
ReadIniKeyhairetsu(ini_file_name,msg) {
	If (msg == 1) {
		SplashImage,,B1 FM12 CWFFFFA2,,キー配列を読み込んでいます
	}
	;-------------------------------------- iniファイルからキー配列情報を取得
	loop {
		section = KEYHAIRETSU%A_Index%
		IniRead,key_index,%ini_file_name%,%section%,KeyAssign,-1
		If (key_index == -1) {
			Break
		}
		key_index_alp = %key_index%0
		key_index_jpn = %key_index%1
		;-------------------------------------- 単独打鍵（英数）
		IniRead,ini_data,%ini_file_name%,%section%,KeySingleAlp,-1
		If (ini_data != "-1") {
			key_single[key_index_alp] := ini_data
		}
		;-------------------------------------- 単独打鍵（日本語）
		IniRead,ini_data,%ini_file_name%,%section%,KeySingleJpn,-1
		If (ini_data != "-1") {
			key_single[key_index_jpn] := ini_data
		}
		;-------------------------------------- ＋シフトキー（英数）
		IniRead,ini_data,%ini_file_name%,%section%,KeyLShiftAlp,-1
		If (ini_data != "-1") {
			key_lshift[key_index_alp] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyRShiftAlp,-1
		If (ini_data != "-1") {
			key_rshift[key_index_alp] := ini_data
		}
		;-------------------------------------- ＋シフトキー（日本語）
		IniRead,ini_data,%ini_file_name%,%section%,KeyLShiftJpn,-1
		If (ini_data != "-1") {
			key_lshift[key_index_jpn] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyRShiftJpn,-1
		If (ini_data != "-1") {
			key_rshift[key_index_jpn] := ini_data
		}
		;-------------------------------------- ＋スペシャルキー（英数）
		IniRead,ini_data,%ini_file_name%,%section%,KeySpecialAlp,-1
		If (ini_data != "-1") {
			key_special[key_index_alp] := ini_data
		}
		;-------------------------------------- ＋スペシャルキー（日本語）
		IniRead,ini_data,%ini_file_name%,%section%,KeySpecialJpn,-1
		If (ini_data != "-1") {
			key_special[key_index_jpn] := ini_data
		}
		;-------------------------------------- ＋変換キー（英数）
		IniRead,ini_data,%ini_file_name%,%section%,KeyHenkanAlp,-1
		If (ini_data != "-1") {
			key_henkan[key_index_alp] := ini_data
		}
		;-------------------------------------- ＋変換キー（日本語）
		IniRead,ini_data,%ini_file_name%,%section%,KeyHenkanJpn,-1
		If (ini_data != "-1") {
			key_henkan[key_index_jpn] := ini_data
		}
		;IniRead,ini_data,%ini_file_name%,%section%,KeyHenkanSpecial,-1
		;If (ini_data != "-1") {
		;	key_henkan_special[key_index_jpn] := ini_data
		;}
		;-------------------------------------- ＋変換キー（共通）
		IniRead,ini_data,%ini_file_name%,%section%,KeyHenkanShift,-1
		If (ini_data != "-1") {
			key_henkan_shift[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyHenkanAlt,-1
		If (ini_data != "-1") {
			key_henkan_alt[key_index] := ini_data
		}
		;-------------------------------------- ＋無変換キー（英数）
		IniRead,ini_data,%ini_file_name%,%section%,KeyMuhenkanAlp,-1
		If (ini_data != "-1") {
			key_muhenkan[key_index_alp] := ini_data
		}
		;-------------------------------------- ＋無変換キー（日本語）
		IniRead,ini_data,%ini_file_name%,%section%,KeyMuhenkanJpn,-1
		If (ini_data != "-1") {
			key_muhenkan[key_index_jpn] := ini_data
		}
		;-------------------------------------- ＋無変換キー（共通）
		IniRead,ini_data,%ini_file_name%,%section%,KeyMuhenkanShift,-1
		If (ini_data != "-1") {
			key_muhenkan_shift[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyMuhenkanAlt,-1
		If (ini_data != "-1") {
			key_muhenkan_alt[key_index] := ini_data
		}
		;-------------------------------------- ＋アプリケーションキー（共通）
		IniRead,ini_data,%ini_file_name%,%section%,KeyAppsKey,-1
		If (ini_data != "-1") {
			key_appskey[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyAppsKeyShift,-1
		If (ini_data != "-1") {
			key_appskey_shift[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,KeyAppsKeyAlt,-1
		If (ini_data != "-1") {
			key_appskey_alt[key_index] := ini_data
		}
		;-------------------------------------- タスク制御情報
		IniRead,ini_data,%ini_file_name%,%section%,TaskClass,-1
		If (ini_data != "-1") {
			task_class[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,TaskName,-1
		If (ini_data != "-1") {
			task_name[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,TaskTitle,-1
		If (ini_data != "-1") {
			task_title[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,TaskShortcut,-1
		If (ini_data != "-1") {
			task_shortcut[key_index] := ini_data
		}
		;IniRead,ini_data,%ini_file_name%,%section%,TaskCmd,-1
		;If (ini_data != "-1") {
		;	task_cmd[key_index] := ini_data
		;}
		IniRead,ini_data,%ini_file_name%,%section%,TaskLancherName,-1
		If (ini_data != "-1") {
			task_lancher_name[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,TaskStyle,-1
		If (ini_data != "-1") {
			task_style[key_index] := ini_data
		}
		IniRead,ini_data,%ini_file_name%,%section%,TaskFullPath,-1
		If (ini_data != "-1") {
			task_full_path[key_index] := ini_data
		}
	}
	SplashImage,off
}
;=========================================== キー配列の保存
WriteIniKeyhairetsu(ini_file_name,Messege) {
	SplashImage,,B1 FM12 CWFFFFA2,,%Messege%
	;-------------------------------------- iniファイルにキー配列情報を保存
	loop {
		section = KEYHAIRETSU%A_Index%
		IniRead,key_index,%IniFileName%,%section%,KeyAssign,-1
		If (key_index == -1) {
			Break
		}
		key_index_alp = %key_index%0
		key_index_jpn = %key_index%1
		;-------------------------------------- キーアサイン
		save_data := key_index
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyAssign
		;-------------------------------------- 単独打鍵（英数）
		save_data := key_single[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeySingleAlp
		;-------------------------------------- 単独打鍵（日本語）
		save_data := key_single[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeySingleJpn
		;-------------------------------------- ＋シフトキー（英数）
		save_data := key_lshift[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyLShiftAlp
		save_data := key_rshift[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyRShiftAlp
		;-------------------------------------- ＋シフトキー（日本語）
		save_data := key_lshift[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyLShiftJpn
		save_data := key_rshift[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyRShiftJpn
		;-------------------------------------- ＋Specialキー（英数）
		save_data := key_Special[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeySpecialAlp
		;-------------------------------------- ＋Specialキー（日本語）
		save_data := key_Special[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeySpecialJpn
		;-------------------------------------- ＋変換キー（英数）
		save_data := key_henkan[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyHenkanAlp
		;-------------------------------------- ＋変換キー（日本語）
		save_data := key_henkan[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyHenkanJpn
		save_data := key_henkan_Special[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyHenkanSpecial
		;-------------------------------------- ＋無変換キー（英数）
		save_data := key_muhenkan[key_index_alp]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyMuhenkanAlp
		;-------------------------------------- ＋無変換キー（日本語）
		save_data := key_muhenkan[key_index_jpn]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyMuhenkanJpn
		;-------------------------------------- ＋無変換キー（共通）
		save_data := key_muhenkan_shift[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyMuhenkanShift
		save_data := key_muhenkan_alt[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyMuhenkanAlt
		;-------------------------------------- ＋アプリケーションキー（共通）
		save_data := key_appskey[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyAppsKey
		save_data := key_appskey_shift[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyAppsKeyShift
		save_data := key_appskey_alt[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,KeyAppsKeyAlt
		;-------------------------------------- タスク制御情報
		save_data := task_class[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskClass
		save_data := task_name[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskName
		save_data := task_shortcut[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskShortcut
		;save_data := task_cmd[key_index]
		;IniWrite,%save_data%,%ini_file_name%,%section%,TaskCmd
		save_data := task_lancher_name[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskLancherName
		save_data := task_style[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskStyle
		save_data := task_full_path[key_index]
		IniWrite,%save_data%,%ini_file_name%,%section%,TaskFullPath
	}
	SplashImage,off
}
